<?php
/*
  MailBeez Automatic Trigger Email Campaigns
  http://www.mailbeez.com

  Copyright (c) 2010 MailBeez
	
	inspired and in parts based on
  Copyright (c) 2003 osCommerce

  Released under the GNU General Public License
*/

/*
  $Id: split_page_results.php,v 1.1.1.1 2007/09/06 14:32:42 moritz Exp $

  osCommerce, Open Source E-Commerce Solutions
  http://www.oscommerce.com

  Copyright (c) 2002 osCommerce

  Released under the GNU General Public License
*/

class splitPageResults
{
    function __construct(&$current_page_number, $max_rows_per_page, &$sql_query, &$query_num_rows)
    {
        if (empty($current_page_number)) $current_page_number = 1;

        $pos_to = strlen($sql_query);
        $pos_from = strpos($sql_query, ' from', 0);

        $pos_group_by = strpos($sql_query, ' group by', $pos_from);
        if (($pos_group_by < $pos_to) && ($pos_group_by != false)) $pos_to = $pos_group_by;

        $pos_having = strpos($sql_query, ' having', $pos_from);
        if (($pos_having < $pos_to) && ($pos_having != false)) $pos_to = $pos_having;

        $pos_order_by = strpos($sql_query, ' order by', $pos_from);
        if (($pos_order_by < $pos_to) && ($pos_order_by != false)) $pos_to = $pos_order_by;

        $reviews_count_query = mh_db_query("select count(*) as total " . substr($sql_query, $pos_from, ($pos_to - $pos_from)));
        $reviews_count = mh_db_fetch_array($reviews_count_query);
        $query_num_rows = $reviews_count['total'];

        $num_pages = ceil($query_num_rows / $max_rows_per_page);
        if ($current_page_number > $num_pages) {
            $current_page_number = $num_pages;
        }
        $offset = ($max_rows_per_page * ($current_page_number - 1));
        // 20050329 / mats / sphere informatics / changes for new MySQL-Version / dont's allow something like LIMIT -9,9
        if ($offset < 0) {
            $offset = 0;
        }
        $sql_query .= " limit " . $offset . ", " . $max_rows_per_page;
    }

    function splitPageResults(&$current_page_number, $max_rows_per_page, &$sql_query, &$query_num_rows)
    {
        self::__construct($current_page_number, $max_rows_per_page, $sql_query, $query_num_rows);
    }


    function display_links($query_numrows, $max_rows_per_page, $max_page_links, $current_page_number, $parameters = '', $page_name = 'page')
    {
        global $PHP_SELF;

        if (mh_not_null($parameters) && (substr($parameters, -1) != '&')) $parameters .= '&';

// calculate number of pages needing links
        $num_pages = min(ceil($query_numrows / $max_rows_per_page), 1000);

        $pages_array = array();
        for ($i = 1; $i <= $num_pages; $i++) {
            $pages_array[] = array('id' => $i, 'text' => $i);
        }

        if ($num_pages > 1) {
            $display_links = mh_draw_form('pages', basename($PHP_SELF), '', 'get');

            if ($current_page_number > 1) {
                $display_links .= '<a href="' . mh_href_link(basename($PHP_SELF), $parameters . $page_name . '=' . ($current_page_number - 1), 'NONSSL') . '" class="splitPageLink">' . mh_lng('PREVNEXT_BUTTON_PREV') . '</a>&nbsp;&nbsp;';
            } else {
                $display_links .= mh_lng('PREVNEXT_BUTTON_PREV') . '&nbsp;&nbsp;';
            }

            $display_links .= sprintf(mh_lng('TEXT_RESULT_PAGE'), mh_draw_pull_down_menu($page_name, $pages_array, $current_page_number, 'onChange="this.form.submit();"'), $num_pages);

            if (($current_page_number < $num_pages) && ($num_pages != 1)) {
                $display_links .= '&nbsp;&nbsp;<a href="' . mh_href_link(basename($PHP_SELF), $parameters . $page_name . '=' . ($current_page_number + 1), 'NONSSL') . '" class="splitPageLink">' . mh_lng('PREVNEXT_BUTTON_NEXT') . '</a>';
            } else {
                $display_links .= '&nbsp;&nbsp;' . mh_lng('PREVNEXT_BUTTON_NEXT');
            }

            if ($parameters != '') {
                if (substr($parameters, -1) == '&') $parameters = substr($parameters, 0, -1);
                $pairs = explode('&', $parameters);
                foreach ($pairs as $i => $pair) {
                    list($key, $value) = explode('=', $pair);
                    $display_links .= mh_draw_hidden_field(rawurldecode($key), rawurldecode($value));
                }
            }

            if (SID) $display_links .= mh_draw_hidden_field(mh_session_name(), mh_session_id());

            $display_links .= '</form>';
        } else {
            $display_links = sprintf(mh_lng('TEXT_RESULT_PAGE'), $num_pages, $num_pages);
        }

        return $display_links;
    }

    function display_count($query_numrows, $max_rows_per_page, $current_page_number, $text_output)
    {
        $to_num = ($max_rows_per_page * $current_page_number);
        if ($to_num > $query_numrows) $to_num = $query_numrows;
        $from_num = ($max_rows_per_page * ($current_page_number - 1));
        if ($to_num == 0) {
            $from_num = 0;
        } else {
            $from_num++;
        }

        return sprintf($text_output, $from_num, $to_num, $query_numrows);
    }
}
