<?php

/*
  MailBeez Automatic Trigger Email Campaigns
  http://www.mailbeez.com

  Copyright (c) 2010, 2011, 2012 MailBeez

  inspired and in parts based on
  Copyright (c) 2003 osCommerce

  Released under the GNU General Public License
 */

///////////////////////////////////////////////////////////////////////////////
///																			 //
///                 MailBeez Core file - do not edit                         //
///                                                                          //
///////////////////////////////////////////////////////////////////////////////

require_once(MH_DIR_FS_CATALOG . MH_ROOT_PATH . 'common/classes/configbeez.php');

class config_analytics extends configbeez
{
// class constructor
    function __construct()
    {
        parent::__construct();
        $this->code = 'config_analytics';
        $this->module = 'config_analytics'; // same as folder name
        $this->version = '2.0'; // float value
        $this->title = mh_lng('MAILBEEZ_CONFIG_ANALYTICS_TEXT_TITLE');
        $this->description = mh_lng('MAILBEEZ_CONFIG_ANALYTICS_TEXT_DESCRIPTION');
        $this->description_image = '../../common/images/icon_ma_64.png';
        $this->icon = '../../common/images/icon_ma.png';
        $this->removable = false; // can't be removed
        $this->stealth = true; // don't list as an installed module
        $this->display_as_submodule_of = 'config';
        $this->sort_order = 4;
        $this->enabled = mh_cfg('MAILBEEZ_MAILHIVE_STATUS') == 'True';
        $this->on_cfg_save_clear_template_c = true;

        if (mh_cfg('MAILBEEZ_ANALYTICS_STATUS') == 'False') {
            $this->admin_action_plugins = 'confirm.php';
            $this->admin_action_plugins_path = MH_DIR_CONFIG;
            $this->is_configurable = false;
        }


        $this->documentation_key = 'config_analytics'; // leave empty if no documentation available

        $this->_blueprint();

    }



// class methods

    function getAudience()
    {
        return false;
    }

    function check()
    {
        return true;
    }

    function remove()
    {
        return false;
    }

    // installation methods

    function keys()
    {
        if (mh_cfg('MAILBEEZ_ANALYTICS_STATUS') == 'True') {
            $keys_array = array('MAILBEEZ_ANALYTICS_STATUS', 'MAILBEEZ_ANALYTICS_SUBTOTAL_MODULE', 'MAILBEEZ_ANALYTICS_OPEN_RATES_AUTO', 'MAILBEEZ_ANALYTICS_DO_RUN', 'MAILBEEZ_ANALYTICS_AUTOINSERT_PIX', 'MAILBEEZ_ANALYTICS_REWRITE_FORMAT', 'MAILBEEZ_ANALYTICS_SPLITPAGE_NUM', 'MAILBEEZ_ANALYTICS_BEGIN_OF_TIME');
        }
        return $keys_array;
    }

    function install()
    {
        return false;
    }

    function list_modules($params)
    {

        $ot_modules_installed = explode(';', mh_cfg('MODULE_ORDER_TOTAL_INSTALLED'));
        $ot_modules_array = array();
        foreach ($ot_modules_installed as $ot_mod) {
            $ot_mod = str_replace('.php', '', $ot_mod);
            $ot_modules_array[] = array('id' => $ot_mod, 'text' => $ot_mod);
        }

        $ot_module = $params[0];
        $key = $params[1];

        $name = (($key) ? 'configuration[' . $key . ']' : 'configuration_value');
        return mh_draw_pull_down_menu($name, $ot_modules_array, $ot_module);
    }
}
