<?php

/*
  MailBeez Automatic Trigger Email Campaigns
  http://www.mailbeez.com

  Copyright (c) 2010, 2011 MailBeez

  inspired and in parts based on
  Copyright (c) 2003 osCommerce

  Released under the GNU General Public License
 */

///////////////////////////////////////////////////////////////////////////////
///																																					 //
///                 MailBeez Core file - do not edit                         //
///                                                                          //
///////////////////////////////////////////////////////////////////////////////

require_once(MH_DIR_FS_CATALOG . MH_ROOT_PATH . 'common/classes/configbeez.php');

mh_define('MAILBEEZ_CONFIG_GOOGLEANALYTICS_STATUS', 'True');

class config_googleanalytics extends configbeez
{

// class constructor
    function __construct()
    {
        parent::__construct();
        $this->code = 'config_googleanalytics';
        $this->module = 'config_googleanalytics'; // same as folder name
        $this->version = '2.0'; // float value
        $this->title = mh_lng('MAILBEEZ_CONFIG_GOOGLEANALYTICS_TEXT_TITLE');
        $this->description = mh_lng('MAILBEEZ_CONFIG_GOOGLEANALYTICS_TEXT_DESCRIPTION');
        $this->description_image = '../../common/images/icon_ga_64.png';
        $this->icon = '../../common/images/icon_ga.png';
        $this->removable = false; // can't be removed
        $this->stealth = true; // don't list as an installed module
        $this->display_as_submodule_of = 'config';
        $this->sort_order = 4.1;
        $this->enabled = mh_cfg('MAILBEEZ_MAILHIVE_GA_ENABLED') == 'True';
        $this->status_key = 'MAILBEEZ_CONFIG_GOOGLEANALYTICS_STATUS';

        $this->documentation_key = $this->module; // leave empty if no documentation available
        $this->documentation_root = 'https://www.mailbeez.com/documentation/configbeez/';

        $this->_blueprint();

    }

    function config_googleanalytics()
    {
        self::__construct();
    }

// class methods

    function getAudience()
    {
        return false;
    }

    function check()
    {
        return true;
    }

    function remove()
    {
        return false;
    }

    // installation methods

    function keys()
    {
        return array('MAILBEEZ_MAILHIVE_GA_ENABLED', 'MAILBEEZ_MAILHIVE_GA_REWRITE_MODE', 'MAILBEEZ_MAILHIVE_GA_REWRITE_FORMAT', 'MAILBEEZ_MAILHIVE_GA_MEDIUM', 'MAILBEEZ_MAILHIVE_GA_SOURCE',);
    }

    function install()
    {
        return false;
    }

}

