<?php
use SiteZen\Telemetry\Bootstrap;
use SiteZen\Telemetry\Connectors\Application;


ini_set('display_errors', 1);
ini_set('display_startup_errors', 1);
error_reporting(E_ALL);

define('SITEZEN_CONNECTOR_VERSION', '1.0.0');
define('SITEZEN_CONNECTOR_TYPE', 'mailbeez');

include __DIR__ . '/../sitezen/Bootstrap/bootstrap.php';

include __DIR__ . '/../connectors/Application.php';


// locate env file and map env settings
$envFilePath = realpath(dirname(__FILE__) . '/../.sitezen.env.php');

// load config
$config = Bootstrap\config::config($envFilePath);

// check gate
Bootstrap\Gate::check($config);

// start performance measurement
Bootstrap\Performance::start();

// initialize process handler
$process = new Bootstrap\Process($config);

// register plugin handlers
$process->registerHandler('application:data', function ($request) use ($config) {
    return Application::applicationData($config);
});

$process->registerHandler('application:cleanup', function ($request) use ($config) {
    return [
        'cleanup' => Application::cleanup($config, $request),
    ];
});

$data = $process->executeHandler();

// return data as json
(new Bootstrap\Data($data, Bootstrap\Performance::end()))->output();
