<?php
namespace SiteZen\Telemetry\Bootstrap;

class Env
{
    var $envFilePath;
    var $env;

    public function __construct($envFilePath = '.sitezen.env')
    {

        $this->envFilePath = $envFilePath;


        if (!file_exists($this->envFilePath)) {
            header('X-SiteZen-Status: 400');
            header('HTTP/1.0 400 Bad Request');
            die("Can not load env file: " . $this->envFilePath);
        }

        $envFile = fopen($this->envFilePath, "r");
        if ($envFile) {
            while (($line = fgets($envFile)) !== false) {
                if (!strpos($line, '=') || strpos($line, '#') === 0) {
                    continue;
                }
                list($key, $value) = explode('=', $line, 2);
                $this->env[trim($key)] = trim($value);
            }
            fclose($envFile);
        } else {
            header('X-SiteZen-Status: 400');
            header('HTTP/1.0 400 Bad Request');
            die("Unable to open the file: " . $this->envFilePath);
        }
    }

    public function get($variable): ?string
    {
        return getenv($variable) !== false ? getenv($variable) : $this->env[$variable] ?? null;
    }
}



