<?php

use SiteZen\Telemetry\Bootstrap;

ini_set('display_errors', 1);
ini_set('display_startup_errors', 1);
error_reporting(E_ALL);

define('SITEZEN_CONNECTOR_VERSION', '1.0.0');
define('SITEZEN_CONNECTOR_TYPE', 'generic');

include __DIR__ . '/Bootstrap/bootstrap.php';


// locate env file and map env settings

$envFilePath = realpath(dirname(__FILE__) . '/../.sitezen.env');

// load config

header('X-SiteZen-Version: '. SITEZEN_CONNECTOR_VERSION);
header('X-SiteZen-Type: '. SITEZEN_CONNECTOR_TYPE);

$config = Bootstrap\config::config($envFilePath);
// check gate
Bootstrap\Gate::check($config);
// start performance measurement
Bootstrap\Performance::start();

// connect to database
$db = new \SiteZen\Telemetry\Connectors\Database($config);

// process
$data = (new Bootstrap\Process($db))->toArray();
$db->close();

// return data as json
(new Bootstrap\Data($data, Bootstrap\Performance::end()))->output();
